Xtoman.Admin/Controllers/Other/SupportController.cs
using AutoMapper;
using AutoMapper.QueryableExtensions;
using Microsoft.AspNet.Identity;
using PagedList;
using System;
using System.ComponentModel;
using System.Data.Entity;
using System.Linq;
using System.Threading.Tasks;
using System.Web.Mvc;
using Xtoman.Admin.ViewModels;
using Xtoman.Domain.Models;
using Xtoman.Framework.Mvc;
using Xtoman.Framework.Mvc.Attributes;
using Xtoman.Service;
using Xtoman.Utility;
using Xtoman.Utility.PostalEmail;

namespace Xtoman.Admin.Controllers
{
    [MenuIcon("ti-support")]
    [DisplayName("پشتیبانی")]
    public class SupportController : BaseAdminController
    {
        private readonly ISupportTicketService _supportTicketService;
        private readonly ISupportTicketReplyService _supportTicketReplyService;
        private readonly IUserService _userService;
        private readonly IMessageManager _messageManager;
        public SupportController(
            ISupportTicketService supportTicketService,
            ISupportTicketReplyService supportTicketReplyService,
            IUserService userService,
            IMessageManager messageManager)
        {
            _supportTicketService = supportTicketService;
            _supportTicketReplyService = supportTicketReplyService;
            _userService = userService;
            _messageManager = messageManager;
        }

        public async Task<ActionResult> Index(int? page = 1, SupportDepartment? department = null, TicketStatus? status = null, string term = "")
        {
            var query = _supportTicketService.TableNoTracking;
            if (term.HasValue())
                query = query.Where(p => p.Text.Contains(term) || p.Subject.Contains(term) || p.EmailOrPhoneNumber.Contains(term));

            if (status.HasValue)
            {
                ViewBag.Status = status.ToInt();
                query = query.Where(p => p.Status == status.Value);
            }

            if (department.HasValue)
            {
                ViewBag.Department = department.ToInt();
                query = query.Where(p => p.Department == department.Value);
            }

            //var model = await query
            //    .ProjectToPagedListAsync<SupportTicketListItemViewModel>(p => p.Status, (int)page, 30);

            var pageSize = 30;
            var skip = (page.Value - 1) * pageSize;
            var queryViewModel = query.ProjectTo<SupportTicketListItemViewModel>().OrderBy(x => x.Status).ThenByDescending(x => x.LastDate);
            var totalCount = await query.CountAsync();
            var list = await queryViewModel.Skip(skip).Take(pageSize).ToListAsync();
            var model = new StaticPagedList<SupportTicketListItemViewModel>(list, page.Value, pageSize, totalCount);

            ViewBag.CurrentPage = page;
            return View(model);
        }

        public async Task<ActionResult> Details(int id)
        {
            var model = await _supportTicketService.TableNoTracking
                .Where(p => p.Id == id)
                .ProjectToSingleAsync<SupportTicketViewModel>();

            if (model.UserName.HasValue())
            {
                model.FullName = await _userService.TableNoTracking
                    .Where(p => p.UserName == model.UserName || p.Email == model.EmailOrPhoneNumber || p.PhoneNumber == model.EmailOrPhoneNumber)
                    .Select(p => p.FirstName + " " + p.LastName)
                    .FirstOrDefaultAsync();
            }
            else if (model.InsertUserId.HasValue && model.InsertUserId > 0)
            {
                model.FullName = await _userService.TableNoTracking
                    .Where(p => p.Id == model.InsertUserId.Value)
                    .Select(p => p.FirstName + " " + p.LastName)
                    .FirstOrDefaultAsync();
            }
            return View(model);
        }

        [HttpPost]
        public async Task<ActionResult> SendReply(int TicketId, SupportTicketReplySubmitViewModel model)
        {
            try
            {
                var entity = model.ToEntity();
                entity.SupportTicketId = TicketId;
                await _supportTicketReplyService.InsertAsync(entity);
                SuccessNotification($"پاسخ تیکت شماره {TicketId} ارسال شد.");

                var ticket = await _supportTicketService.Table.Where(p => p.Id == TicketId).SingleAsync();
                ticket.Status = Domain.Models.TicketStatus.Answered;
                ticket.LastDate = DateTime.UtcNow;
                await _supportTicketService.UpdateAsync(ticket);

                var ticketUrl = $"https://www.extoman.co/Support/Ticket/{ticket.Id}";
                var supportTicketAnswerEmail = new SupportTicketAnswerEmail()
                {
                    From = "no-reply@extoman.com",
                    Subject = $"پاسخ درخواست پشتیبانی با موضوع {ticket.Subject}",
                    To = ticket.EmailOrPhoneNumber,
                    Username = ticket.UserName,
                    ViewName = "SupportTicketAnswer",
                    Fullname = ticket.EmailOrPhoneNumber,
                    TicketSubject = ticket.Subject,
                    TicketText = ticket.Text,
                    TicketUrl = ticketUrl
                };

                var answerUserName = User.Identity.GetUserName();
                var emailBody = supportTicketAnswerEmail.GetMailMessage().Body;
                await _messageManager.SupportTicketAnsweredAsync(emailBody, ticket.Subject, ticketUrl, ticket.EmailOrPhoneNumber, answerUserName);
            }
            catch (Exception ex)
            {
                ErrorNotification(ex.Message);
            }
            return RedirectToAction("Index");
        }

        [ChildActionOnly]
        public virtual ActionResult WaitingCount()
        {
            var count = _supportTicketService.TableNoTracking
                .Where(p => p.Status == Domain.Models.TicketStatus.WaitingReply)
                .Count();
            return Content(count.ToString());
        }

        [ChildActionOnly]
        public virtual ActionResult OpenCount()
        {
            var count = _supportTicketService.TableNoTracking
                .Where(p => p.Status == Domain.Models.TicketStatus.Answered)
                .Count();
            return Content(count.ToString());
        }

        [HttpPost]
        [AjaxOnly]
        public virtual async Task<ActionResult> CloseOne(int id)
        {
            var result = new ResultModel();
            try
            {
                var ticket = await _supportTicketService.Table.SingleAsync(p => p.Id == id);
                ticket.Status = TicketStatus.Closed;

                await _supportTicketService.UpdateAsync(ticket);

                result.Text = $"تیکت بسته شد.";
                result.Status = true;
            }
            catch (Exception ex)
            {
                result.Text = ex.Message;
            }
            return Json(result);
        }

        [HttpPost]
        [AjaxOnly]
        public virtual async Task<ActionResult> Close(TicketStatus? type = null)
        {
            var result = new ResultModel();
            try
            {
                var query = _supportTicketService.Table.Where(p => p.Status != TicketStatus.Closed);
                if (type != null)
                    query = query.Where(p => p.Status == type.Value);

                var tickets = await query.ToListAsync();

                foreach (var ticket in tickets)
                    ticket.Status = TicketStatus.Closed;

                await _supportTicketService.UpdateAsync(tickets);

                result.Text = $"تعداد {tickets.Count} بسته شد.";
                result.Status = true;
            }
            catch (Exception ex)
            {
                result.Text = ex.Message;
            }
            return Json(result);
        }
    }
}

Xtoman.Admin/Controllers/User/UserController.cs
using AutoMapper;
using Microsoft.AspNet.Identity;
using System;
using System.ComponentModel;
using System.Data.Entity;
using System.Linq;
using System.Threading.Tasks;
using System.Web.Mvc;
using Xtoman.Admin.ViewModels;
using Xtoman.Domain.Models;
using Xtoman.Framework.Core;
using Xtoman.Framework.Mvc;
using Xtoman.Framework.Mvc.Attributes;
using Xtoman.Service;
using Xtoman.Utility;

namespace Xtoman.Admin.Controllers
{
    [MenuIcon("ti-user")]
    [DisplayName("کاربران")]
    public class UserController : BaseAdminController
    {
        #region Properties
        private readonly IUserService _userService;
        private readonly IMessageManager _messageManager;
        private readonly IExchangeOrderService _exchangeOrderService;
        private readonly ISupportTicketService _supportTicketService;
        private readonly IUserVerificationService _userVerificationService;
        private readonly IAppUserManager _userManager;
        #endregion

        #region Constructor
        public UserController(
            IUserService userService,
            IMessageManager messageManager,
            IExchangeOrderService exchangeOrderService,
            ISupportTicketService supportTicketService,
            IUserVerificationService userVerificationService,
            IAppUserManager userManager)
        {
            _userService = userService;
            _messageManager = messageManager;
            _exchangeOrderService = exchangeOrderService;
            _supportTicketService = supportTicketService;
            _userVerificationService = userVerificationService;
            _userManager = userManager;
        }
        #endregion

        #region Actions
        public ActionResult Index()
        {
            //var model = await _userService.TableNoTracking
            //    .OrderByDescending(p => p.Id)
            //    .ProjectToPagedListAsync<UserViewModel>(page, psize);

            return View();
        }

        public async Task<ActionResult> Search(UserSearchTerms term, int page = 1, int pageSize = 30)
        {
            var query = _userService.TableNoTracking;
            if (term.Text.HasValue())
            {
                var termInt = term.Text.TryToInt();
                query = query.Where(p => p.FirstName == term.Text ||
                                         p.LastName == term.Text ||
                                         (p.FirstName + " " + p.LastName) == term.Text ||
                                         p.Email == term.Text || p.PhoneNumber == term.Text ||
                                         p.Id == termInt ||
                                         p.Telephone == term.Text ||
                                         p.UserBankCards.Any(x => x.CardNumber == term.Text));

            }

            if (term.FromId.HasValue)
                query = query.Where(p => p.Id >= term.FromId);

            if (term.ToId.HasValue)
                query = query.Where(p => p.Id <= term.ToId);

            if (term.Gender.HasValue)
            {
                var gender = term.Gender.Value == 0;
                query = query.Where(p => p.Gender == gender);
            }

            if (term.IsPhisher.HasValue)
            {
                var IsPhisher = term.IsPhisher.Value == 1;
                query = query.Where(p => p.IsPhisher == IsPhisher);
            }

            if (term.VerifyStatus.HasValue)
            {
                switch (term.VerifyStatus.Value)
                {
                    case VerificationModelStatus.IdentityNotSent:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.NotSent);
                        break;
                    case VerificationModelStatus.IdentityPending:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.Pending);
                        break;
                    case VerificationModelStatus.IdentityConfirmed:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.Confirmed);
                        break;
                    case VerificationModelStatus.IdentityNotConfirmed:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.NotConfirmed);
                        break;
                    case VerificationModelStatus.TelephoneNotEntered:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.Confirmed && p.Telephone == null);
                        break;
                    case VerificationModelStatus.TelephonePending:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.Confirmed && p.TelephoneConfirmationStatus == VerificationStatus.Pending);
                        break;
                    case VerificationModelStatus.TelephoneNotConfirmed:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.Confirmed && p.TelephoneConfirmationStatus == VerificationStatus.NotConfirmed);
                        break;
                    case VerificationModelStatus.TelephoneConfirmed:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.Confirmed && p.TelephoneConfirmationStatus == VerificationStatus.Confirmed);
                        break;
                    case VerificationModelStatus.PhoneNumberNotEntered:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.Confirmed && p.PhoneNumber == null);
                        break;
                    case VerificationModelStatus.PhoneNumberNotConfirmed:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.Confirmed && p.PhoneNumber != null && !p.PhoneNumberConfirmed);
                        break;
                    case VerificationModelStatus.PhoneNumberConfirmed:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.Confirmed && p.PhoneNumber != null && p.PhoneNumberConfirmed);
                        break;
                    case VerificationModelStatus.EmailNotEntered:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.Confirmed && p.Email == null);
                        break;
                    case VerificationModelStatus.EmailNotConfirmed:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.Confirmed && p.Email != null && !p.EmailConfirmed);
                        break;
                    case VerificationModelStatus.EmailConfirmed:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.Confirmed && p.Email != null && p.EmailConfirmed);
                        break;
                    case VerificationModelStatus.BankCardNotEntered:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.Confirmed && !p.UserBankCards.Any());
                        break;
                    case VerificationModelStatus.BankCardPending:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.Confirmed && p.UserBankCards.Any(x => x.VerificationStatus == VerificationStatus.Pending));
                        break;
                    case VerificationModelStatus.BankCardNotConfirmed:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.Confirmed && !p.UserBankCards.Any(x => x.VerificationStatus == VerificationStatus.Confirmed) && p.UserBankCards.Any(x => x.VerificationStatus == VerificationStatus.NotConfirmed));
                        break;
                    case VerificationModelStatus.BankCardConfirmed:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.Confirmed && p.UserBankCards.Any(x => x.VerificationStatus == VerificationStatus.Confirmed));
                        break;
                    case VerificationModelStatus.Confirmed:
                        query = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.Confirmed && p.EmailConfirmed && p.PhoneNumberConfirmed && p.TelephoneConfirmationStatus == VerificationStatus.Confirmed && p.UserBankCards.Any(x => x.VerificationStatus == VerificationStatus.Confirmed));
                        break;
                }
            }

            var count = await query.CountAsync();
            var list = await query.ProjectToPagedListAsync<UserViewModel>(page, pageSize);

            var totalVerified = query.Where(p => p.IdentityVerificationStatus == VerificationStatus.Confirmed && p.EmailConfirmed && p.PhoneNumberConfirmed && p.TelephoneConfirmationStatus == VerificationStatus.Confirmed && p.UserBankCards.Any(x => x.VerificationStatus == VerificationStatus.Confirmed));
            ViewBag.TotalVerified = await totalVerified
                .CountAsync();

            ViewBag.TotalLoyal = await totalVerified
                .Where(p => p.Orders.Where(x => x.OrderStatus == OrderStatus.Complete).Count() >= 3)
                .CountAsync();

            ViewBag.TotalCount = count;

            return PartialView("_List", list);
        }

        [HttpGet]
        public async Task<ActionResult> Edit(int id)
        {
            var model = await _userService.TableNoTracking.Where(p => p.Id == id)
                .ProjectToSingleAsync<EditUserViewModel>();
            return View(model);
        }

        [HttpPost]
        public async Task<ActionResult> Edit(EditUserViewModel model)
        {
            if (!ModelState.IsValid)
                return View(model);

            var entity = await _userService.Table
                .Where(p => p.Id == model.Id)
                .SingleAsync();

            try
            {
                model.ToEntity(entity);

Xtoman.Admin/Views/Support/Details.cshtml
@model SupportTicketViewModel
@{
    ViewBag.Title = "درخواست پشتیبانی " + Model.Id;
}

<div class="row m-t-20">
    <div class="col-md-3">
        <div class="card-box">
            <h5 class="m-t-0 font-18"><b>جزئیات تیکت</b></h5>
            <hr />
            <span class="font-13 m-0">وضعیت تیکت: <span class="badge badge-@Model.Status.ToDisplay(DisplayProperty.ShortName)">@Model.Status.ToDisplay()</span></span><br />
            <span class="font-13 m-0">دپارتمان: @Model.Department.ToDisplay()</span><br />
            @if (Model.UpdateUser != null)
            {
                <span class="font-13 m-0">پیگیری کننده تیکت: @Model.UpdateUser.FullName</span><br />
            }
            <div class="btn-group" role="group">
                <button class="btn btn-success" onclick="javascript:closeTicket(@Model.Id)"><span class="fa fa-check"></span> بستن تیکت</button>
            </div>
        </div>
    </div>
    <div class="col-md-9">
        <div class="card-box">
            <h4 class="m-t-0 font-18"><b>@Model.Subject</b></h4>
            <hr>
            <div class="media m-b-30">
                <div class="media-body">
                    <span class="media-meta pull-right">@Model.InsertDate.ToFaDateTimeZone()</span>
                    <h4 class="text-primary font-16 m-0"><a href="@Url.Action("Detail", "User")?id=@Model.EmailOrPhoneNumber" target="_blank">@Model.FullName</a></h4>
                    <a href="@Url.Action("Detail", "User")?id=@Model.EmailOrPhoneNumber" target="_blank"><small class="text-muted">فرستنده: @Model.EmailOrPhoneNumber</small></a>
                </div>
            </div>
            <p>@Model.Text</p>
        </div>
        @if (Model.Replies != null && Model.Replies.Any())
        {
            foreach (var item in Model.Replies)
            {
                <hr />
                <div class="card-box m-t-20" style="@(item.IsSupportReply ? "background-color:#808080; border-color:#565656; color:#fff !important;" : "")">
                    <div class="media m-b-30">
                        <div class="media-body">
                            <span class="media-meta pull-right">@item.InsertDate.ToFaDateTimeZone()</span>
                            <h4 class="text-primary font-13 m-0">@item.InsertUserUserName</h4>
                            <small class="text-muted">فرستنده: @item.InsertUserFullName</small>
                        </div>
                    </div>
                    <p>@item.Text</p>
                </div>
            }
        }
        <hr />
        @using (Html.BeginForm("SendReply", "Support", new { TicketId = Model.Id }, FormMethod.Post))
        {
            <div class="form-group">
                <label class="col-form-label">متن پاسخ</label>
                <div class="input-group">
                    <span class="input-group-addon"><i class="fa fa-pencil"></i></span>
                    <textarea class="form-control" id="Text" name="Text" placeholder="متن پاسخ" rows="5"></textarea>
                </div>
            </div>
            <button type="submit" class="btn btn-lg btn-primary float-right">ارسال</button>
        }
    </div>
</div>

@section scripts{
    <script>
        function closeTicket(id) {
            doAjax({ id: id }, "@Url.Action("CloseOne")", function (data) {
                if (data.Status) {
                    window.location.reload();
                }
            });
        }
    </script>    
}

Xtoman.Admin/Views/Support/Index.cshtml
@model PagedList.IPagedList<SupportTicketListItemViewModel>
@using Xtoman.Domain.Models

@{
    var selectedStatus = ViewBag.Status != null ? Convert.ToInt32(ViewBag.Status) : 0;
    var selectedDepartment = ViewBag.Department != null ? Convert.ToInt32(ViewBag.Department) : 0;
}


<div class="row">
    <div class="col-12">
        <button class="btn btn-sm btn-primary" onclick="javascript:closeAnswereds()">بستن همه تیکت های پاسخ داده شده</button>
        <button class="btn btn-sm btn-danger" onclick="javascript:closeAll()">بستن همه تیکت ها</button>

    </div>
    <hr />
    <br />
    <div class="col-12">
        <form method="get">
            <div class="row">
                <div class="col-3">
                    <div class="form-group">
                        <label for="term">عبارت جستجو</label>
                        <input type="text" id="term" name="term" class="form-control" />
                    </div>
                </div>
                <div class="col-3">
                    <div class="form-group">
                        <label for="Status">وضعیت تیکت</label>
                        <select id="Status" name="Status" class="form-control">
                            <option value="">همه</option>
                            @foreach (TicketStatus status in (TicketStatus[])Enum.GetValues(typeof(TicketStatus)))
                            {
                                <option@(selectedStatus > 0 && selectedStatus == status.ToInt() ? " selected":"") value="@status.ToInt()">@status.ToDisplay(DisplayProperty.Name)</option@(selectedStatus)>
                            }
                        </select>
                    </div>
                </div>
                <div class="col-3">
                    <div class="form-group">
                        <label for="Department">دپارتمان</label>
                        <select id="Department" name="Department" class="form-control">
                            <option value="">همه</option>
                            @foreach (SupportDepartment dep in (SupportDepartment[])Enum.GetValues(typeof(SupportDepartment)))
                            {
                                <option@(selectedDepartment > 0 && selectedDepartment == dep.ToInt() ? " selected":"") value="@dep.ToInt()">@dep.ToDisplay(DisplayProperty.Name)</option>
                            }
                        </select>
                    </div>
                </div>
                <div class="col-3">
                    <button class="btn btn-primary btn-block mt-4" type="submit">جستجو</button>
                    <input type="hidden" name="page" id="page" value="@ViewBag.CurrentPage" />
                </div>
            </div>

        </form>
    </div>
    <div class="col-12">
        <div class="row">
            <div class="col-12">
                <h5>نتایج یافته شده: <b>@Model.TotalItemCount</b></h5>
            </div>
        </div>
        <div class="card-box table-responsive font-13">
            @Html.DataTables(
                        @<thead>
                            <tr>
                                <th>
                                    @Html.DisplayNameFor(model => model.GetObject().Id)
                                </th>
                                <th>
                                    @Html.DisplayNameFor(model => model.GetObject().Status)
                                </th>
                                <th>
                                    @Html.DisplayNameFor(model => model.GetObject().Priority)
                                </th>
                                <th>
                                    @Html.DisplayNameFor(model => model.GetObject().EmailOrPhoneNumber)
                                </th>
                                <th>
                                    @Html.DisplayNameFor(model => model.GetObject().Subject)
                                </th>
                                <th>
                                    @Html.DisplayNameFor(model => model.GetObject().Department)
                                </th>
                                <th>
                                    @Html.DisplayNameFor(model => model.GetObject().RepliesCount)
                                </th>
                                <th>
                                    @Html.DisplayNameFor(model => model.GetObject().LastDate)
                                </th>
                                <th>
                                    <span>عملیات</span>
                                </th>
                            </tr>
                        </thead>,
                        @<tbody>
                            @foreach (var support in Model)
                                 {
                                <tr>
                                    <td>
                                        @Html.DisplayFor(modelItem => support.Id)
                                    </td>
                                    <td>
                                        <span class="badge badge-@support.Status.ToDisplay(DisplayProperty.ShortName)" style="padding: inherit;">
                                            @support.Status.ToDisplay()
                                        </span>
                                    </td>
                                    <td>
                                        <span class="badge badge-@support.Priority.ToDisplay(DisplayProperty.ShortName)" style="padding: inherit;">
                                            @support.Priority.ToDisplay()
                                        </span>
                                    </td>
                                    <td>
                                        @Html.DisplayFor(modelItem => support.EmailOrPhoneNumber)
                                    </td>
                                    <td>
                                        @Html.DisplayFor(modelItem => support.Subject)
                                    </td>
                                    <td>
                                        @support.Department.ToDisplay()
                                    </td>
                                    <td>
                                        @Html.DisplayFor(modelItem => support.RepliesCount)
                                    </td>
                                    <td>
                                        @support.LastDate.ToFaDateTimeZone()
                                    </td>
                                    <td>
                                        @Html.ActionLink("مشاهده", "Details", new { id = support.Id }, new { @class = "btn btn-primary" })
                                    </td>
                                </tr>
                                 }
                        </tbody>).Order(1, DataTabledOrder.Asc)
                        <div class="text-center">
                            @Html.Partial("_Paging", Model)
                        </div>
                    </div>
                </div>
            </div>

            @section scripts{
                <script>
        var closeUrl = "@Url.Action("Close")";
        function closeAll() {
            doAjax(null, closeUrl, function () {
                window.location.reload();
            });
        }

        function closeAnswereds() {
            var postData = { type: @((int)Xtoman.Domain.Models.TicketStatus.Answered) };
            doAjax(postData, closeUrl, function () {
                window.location.reload();
            });
        }
                </script>
            }